diff --git a/libr/core/cmd_flag.c b/libr/core/cmd_flag.c
index 1e7f67cdbb3e4..f632b4a889be7 100644
--- a/libr/core/cmd_flag.c
+++ b/libr/core/cmd_flag.c
@@ -819,13 +819,23 @@ static int cmd_flag(void *data, const char *input) {
 					addr = r_num_math (core->num, arg + 1);
 				}
 				break;
-			case '.':
-				strict_offset = true;
+			case '.': // list all flags at given offset
+				{
+				RFlagItem *flag;
+				RListIter *iter;
+				const RList *flaglist;
 				arg = strchr (input, ' ');
 				if (arg) {
 					addr = r_num_math (core->num, arg + 1);
 				}
-				break;
+				flaglist = r_flag_get_list (core->flags, addr);
+				r_list_foreach (flaglist, iter, flag) {
+					if (flag) {
+						r_cons_println (flag->name);
+					}
+				}
+				return 0;
+				}
 			case 'w':
 				{
 				arg = strchr (input, ' ');
